/*
 * Copyright 2005-2010 the original author or authors.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wamblee.concurrency;

/**
 * Represents a re-entrant lock. Implementations can provide inmemory JVM
 * locking or full cluster safe locking mechanisms.
 * 
 * @author Erik Brakkee
 */
public interface Lock {
    /**
     * Acquires the lock.
     */
    void acquire();

    /**
     * Releases the lock.
     */
    void release();
}
